;   ,    HID_Lib  http://pure-basic.narod.ru/libs.html#HID_Lib
;  - PureBasic  4.40  .

CompilerIf Defined(HID_Lib_DeviceTest, #PB_Function) = 0
  CompilerError "  ,   HID_Lib"
CompilerEndIf

#USB_PID=$F4EF  ;  USB 
#USB_VID=$AB80

Global W_DeviceHandle=0, R_DeviceHandle=0 ;  

Procedure FindDevice_Timer() ;    USB .
Static Old_Test
Test=HID_Lib_DeviceTest(#USB_PID, #USB_VID) ;   (1),   (0)
 If Test<>Old_Test
  Old_Test=Test
  If Test                                                  ;   
     HID_Lib_CloseDevice(W_DeviceHandle) 
     HID_Lib_CloseDevice(R_DeviceHandle)
     R_DeviceHandle=HID_Lib_OpenDevice(#USB_PID, #USB_VID) ;    
     W_DeviceHandle=HID_Lib_OpenDevice(#USB_PID, #USB_VID) ;    .
     SetGadgetText(1," HID ")
     DisableGadget(2,0) : DisableGadget(3,0)
  Else                                                     ;   
     HID_Lib_CloseDevice(W_DeviceHandle)                   ;  ,   
     HID_Lib_CloseDevice(R_DeviceHandle)
     W_DeviceHandle=0 : R_DeviceHandle=0
     SetGadgetText(1,"  ")
     SetGadgetText(5,"")
     DisableGadget(2,1) : DisableGadget(3,1)
  EndIf
 EndIf
EndProcedure

Procedure SendDevice(Command.a) ;   USB .
 Dim Out.a(2)
 Out(0) = 0
 Out(1) = Command
 If W_DeviceHandle
   HID_Lib_WriteDevice(W_DeviceHandle, @Out(),2) ;   (2 )  
 Else
   MessageRequester("", "   !", 48)
 EndIf
EndProcedure

Procedure Thread(*xx) ;      .
  Dim In.a(2)
  Repeat
    If R_DeviceHandle
      In(0) = 0
      If HID_Lib_ReadDevice(R_DeviceHandle, @In(), 2) = 2 ;    USB .
        If In(1) = 0
          SetGadgetText(5,"")
        Else
          SetGadgetText(5,"")
        EndIf
      EndIf
    EndIf
    Delay(10)
  ForEver
EndProcedure

OpenWindow(0,0,0,320,100,"   HID ",#PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
   TextGadget(1,10,10,300,16,"  ",#PB_Text_Center)
   ButtonGadget(2,40,70,120,24," ") : DisableGadget(2,1)
   ButtonGadget(3,170,70,120,24," ") : DisableGadget(3,1)
   TextGadget(4,50,40,108,16," :")
   StringGadget(5,158,36,70,20,"",1|#PB_String_ReadOnly)
FindDevice_Timer()
HideWindow(0,0)

AddWindowTimer(0,2,200)   ;  ,     200 
CreateThread(@Thread(),0) ;    Thread()   

Repeat ;   
  Event=WaitWindowEvent()
  If Event=#PB_Event_Gadget ;      
    Select EventGadget()
      Case 2          ;    " "
        SendDevice(1)
      Case 3          ;    " "
        SendDevice(0)
    EndSelect
  ElseIf Event=#PB_Event_Timer
    If EventTimer()=2
      FindDevice_Timer()
    EndIf
  EndIf
Until Event=#PB_Event_CloseWindow ;    ,   
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 52
; FirstLine = 33
; Folding = -
; EnableThread
; EnableXP
; UseIcon = .ico
; Executable = HID_Demo.exe
; SubSystem = UserLibThreadSafe