$regfile = "m8def.dat"                            '   .
$crystal = 12000000                               '  , .
$hwstack = 50                                     '  .
$swstack = 30                                     '   .
$framesize = 40

$include "USB_Config.bas"                         '     
                                                             '  USB .
Config Pinc.0 = Output                            ' PC0 - .
Config 1wire = Portb.0                            '  PB0   DS18B20.
Config Timer1 = Timer , Prescale = 256            '   Timer1.
On Timer1 Setflag Nosave                          '     Timer1
Enable Timer1                                     '    Timer1

Dim 1wire_array(9) As Byte                        '  
Dim Flaginputtermo As Byte                        '  .

1wreset                                           '  .
1wwrite &HCC                                      '  "Skip ROM".
1wwrite &H44                                      '  "Convert  T".

Enable Interrupts                                 '   

Do                                                '   Do -  Loop

  Call Usb_refresh()
 '   
 If _usb_status._usb_rxc = 1 Then
   If _usb_status._usb_setup = 1 Then
     '  
     Call Usb_processsetup(_usb_tx_status)
   End If
   '     
   _usb_status._usb_rtr = 1
   _usb_status._usb_rxc = 0
 End If

 If Flaginputtermo = 1 Then                       '    .
   Flaginputtermo = 0
   Portc.0 = 1                                    '  HL1.
   1wreset                                        '  .
   1wwrite &HCC                                   '  "Skip ROM"
   1wwrite &HBE                                   '  "Read Scratchpad".
   1wire_array(1) = 1wread(9)                     '    .
   1wreset                                        '  .
   1wwrite &HCC                                   '  "Skip ROM".
   1wwrite &H44                                   '  "Convert  T".
   If 1wire_array(9) = Crc8(1wire_array(1) , 8) Then       '   .
     If _usb_tx_status2._usb_txc = 1 Then         '     
       _usb_tx_buffer2(2) = 1wire_array(1)        '  
       _usb_tx_buffer2(3) = 1wire_array(2)        '   
       Call Usb_send(_usb_tx_status2 , 2)         '   .
       Portc.0 = 0                                '  HL1.
     End If
   End If
 End If

Loop                                              '   .
End

Setflag:                                          '    Timer1
 Enable Interrupts                                '   
 Flaginputtermo = 1
 Timer1 = 18660
Return

$include "USB_Descriptor.bas"                     '  s   
$include "USB_Subroutines.bas"                    '   .
